Index: /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/lpj_establish.f90
===================================================================
--- /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/lpj_establish.f90	(revision 256)
+++ /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/lpj_establish.f90	(revision 257)
@@ -428,51 +564,202 @@
 
           ! compare establishment rate and present number of inidivuals
-          many_new(:) = ( d_ind(:,j) .GT. 0.1 * ind(:,j) )
+          !many_new(:) = ( d_ind(:,j) .GT. 0.1 * ind(:,j) )
 
           ! gives a better vectorization of the VPP
 
-          IF ( ANY( many_new(:) ) ) THEN
-
-             DO k = 1, nparts
-
-                WHERE ( many_new(:) )
-
-                   bm_new(:) = d_ind(:,j) * bm_sapl(j,k) / veget_max (:,j)
-
-                   biomass(:,j,k) = biomass(:,j,k) + bm_new(:)
-
-                   !NV passage 2D
-                   co2_to_bm(:,j) = co2_to_bm(:,j) + bm_new(:) / dt
-
-                ENDWHERE
-
+          !IF ( ANY( many_new(:) ) ) THEN
+
+          ! save old leaf mass to calculate leaf age
+          leaf_mass_young(:) = leaf_frac(:,j,1) * biomass(:,j,ileaf)
+          ! total biomass of existing PFT to limit biomass added from establishment
+          total_bm_c(:) = zero
+
+          DO k = 1, nparts
+             total_bm_c(:)=total_bm_c(:)+biomass(:,j,k)
+          ENDDO
+          IF(control%ok_dgvm) THEN
+             vn(:)=veget_max(:,j)
+          ELSE
+             vn(:)=1.0
+          ENDIF
+          total_bm_sapl(:)=zero
+          DO k = 1, nparts
+             WHERE(d_ind(:,j).GT.min_stomate.AND.vn(:).GT.min_stomate)
+
+                total_bm_sapl(:) = total_bm_sapl(:) + & 
+                     bm_sapl(j,k) * d_ind(:,j) / vn(:)
+             ENDWHERE
+          ENDDO
+
+          IF(control%ok_dgvm) THEN
+             ! SZ calculate new woodmass_ind and veget_max after establishment (needed for correct scaling!)
+             ! essential correction for MERGE!
+             IF(tree(j))THEN
+                DO i=1,npts
+                   IF((d_ind(i,j)+ind(i,j)).GT.min_stomate) THEN
+
+                      IF((total_bm_c(i).LE.min_stomate) .OR. (veget_max(i,j) .LE. min_stomate)) THEN
+
+                         ! new wood mass of PFT
+                         woodmass_ind(i,j) = &
+                              & (((biomass(i,j,isapabove)+biomass(i,j,isapbelow) &
+                              & +biomass(i,j,iheartabove)+biomass(i,j,iheartbelow))*veget_max(i,j)) &
+                              & +(bm_sapl(j,isapabove)+bm_sapl(j,isapbelow) &
+                              & +bm_sapl(j,iheartabove)+bm_sapl(j,iheartbelow))*d_ind(i,j))/(ind(i,j)+d_ind(i,j))
+
+                      ELSE 
+                         ! new biomass is added to the labile pool, hence there is no change in CA associated with establishment
+                         woodmass_ind(i,j) = &
+                              & (biomass(i,j,isapabove)+biomass(i,j,isapbelow) &
+                              & +biomass(i,j,iheartabove)+biomass(i,j,iheartbelow))*veget_max(i,j) &
+                              & /(ind(i,j)+d_ind(i,j))
+
+                      ENDIF
+
+                      ! new diameter of PFT
+                      dia(i) = (woodmass_ind(i,j)/(pipe_density*pi/4.*pipe_tune2)) &
+                           &                **(1./(2.+pipe_tune3))
+
+                      vn(:)=(ind(i,j)+d_ind(i,j))*pipe_tune1*MIN(dia(i),maxdia(j))**pipe_tune_exp_coeff
+
+                   ENDIF
+                ENDDO
+             ELSE ! for grasses, cnd=1, so the above calculation cancels
+                vn(:)=ind(:,j)+d_ind(:,j)
+             ENDIF
+          ELSE ! static
+             DO i=1,npts
+                IF(tree(j).AND.(d_ind(i,j)+ind(i,j)).GT.min_stomate) THEN
+                   IF(total_bm_c(i).LE.min_stomate) THEN
+
+                      ! new wood mass of PFT
+                      woodmass_ind(i,j) = &
+                           & (((biomass(i,j,isapabove)+biomass(i,j,isapbelow) &
+                           & +biomass(i,j,iheartabove)+biomass(i,j,iheartbelow))) &
+                           & +(bm_sapl(j,isapabove)+bm_sapl(j,isapbelow) &
+                           & +bm_sapl(j,iheartabove)+bm_sapl(j,iheartbelow))*d_ind(i,j))/(ind(i,j)+d_ind(i,j))
+
+                   ELSE ! new biomass is added to the labile pool, hence there is no change in CA associated with establishment
+
+                      woodmass_ind(i,j) = &
+                           & (biomass(i,j,isapabove)+biomass(i,j,isapbelow) &
+                           & +biomass(i,j,iheartabove)+biomass(i,j,iheartbelow)) &
+                           & /(ind(i,j)+d_ind(i,j))
+
+                   ENDIF
+                ENDIF
              ENDDO
 
-             ! reset leaf ages. Should do a real calculation like in the npp routine, 
-             ! but this case is rare and not worth messing around.
-
-             WHERE ( many_new(:) )
-                leaf_age(:,j,1) = 0.0
-                leaf_frac(:,j,1) = 1.0
-             ENDWHERE
-
-             DO m = 2, nleafages
-
-                WHERE ( many_new(:) )
-                   leaf_age(:,j,m) = 0.0
-                   leaf_frac(:,j,m) = 0.0
-                ENDWHERE
-
-             ENDDO
-
-          ENDIF   ! establishment rate is large
-
-          WHERE ( d_ind(:,j) .GT. 0.0 )
-
-             ! 4.5.2 age decreases
+             vn(:)=1.0 ! cannot change in static!, and veget_max implicit in d_ind
+
+          ENDIF
+          ! total biomass of PFT added by establishment defined over veget_max ...
+          total_bm_sapl(:)=zero
+          DO k = 1, nparts
+             WHERE(d_ind(:,j).GT.min_stomate.AND.total_bm_c(:).GT.min_stomate.AND.vn(:).GT.min_stomate)
+
+                total_bm_sapl(:) = total_bm_sapl(:) + & 
+                     bm_sapl(j,k) * d_ind(:,j) / vn(:)
+             ENDWHERE
+
+          ENDDO
+
+          DO k = 1, nparts
+
+             bm_new(:)=zero
+
+             ! first ever establishment, C flows
+             WHERE( d_ind(:,j).GT.min_stomate .AND. &
+                  total_bm_c(:).LE.min_stomate .AND. &
+                  vn(:).GT.min_stomate)
+                ! WHERE ( many_new(:) )
+
+                !bm_new(:) = d_ind(:,j) * bm_sapl(j,k) / veget_max (:,j)
+                bm_new(:) = d_ind(:,j) * bm_sapl(j,k) / vn(:)
+
+                biomass(:,j,k) = biomass(:,j,k) + bm_new(:)
+
+                co2_to_bm(:,j) = co2_to_bm(:,j) + bm_new(:) / dt
+
+             ENDWHERE
+
+             ! establishment into existing population, C flows
+             WHERE(d_ind(:,j).GT.min_stomate.AND.total_bm_c(:).GT.min_stomate)
+
+                bm_new(:) = total_bm_sapl(:) * biomass(:,j,k) / total_bm_c(:)
+
+                biomass(:,j,k) = biomass(:,j,k) + bm_new(:)
+                co2_to_bm(:,j) = co2_to_bm(:,j) + bm_new(:) / dt
+
+             ENDWHERE
+          ENDDO
+
+          ! reset leaf ages. Should do a real calculation like in the npp routine, 
+          ! but this case is rare and not worth messing around.
+          ! SZ 080806, added real calculation now, because otherwise leaf_age/leaf_frac
+          ! are not initialised for the calculation of vmax, and hence no growth at all.
+          ! logic follows that of stomate_npp.f90, just that it's been adjusted for the code here
+          !
+          ! 4.5.2 Decrease leaf age in youngest class if new leaf biomass is higher than old one.
+          !
+
+!!$          WHERE ( many_new(:) )
+!!$             leaf_age(:,j,1) = zero
+!!$             leaf_frac(:,j,1) = un
+!!$          ENDWHERE
+!!$
+!!$          DO m = 2, nleafages
+!!$
+!!$             WHERE ( many_new(:) )
+!!$                leaf_age(:,j,m) = zero
+!!$                leaf_frac(:,j,m) = zero
+!!$             ENDWHERE
+!!$
+!!$          ENDDO
+
+          WHERE ( d_ind(:,j) * bm_sapl(j,ileaf) .GT. min_stomate ) 
+
+             leaf_age(:,j,1) = leaf_age(:,j,1) * leaf_mass_young(:) / &
+                  ( leaf_mass_young(:) + d_ind(:,j) * bm_sapl(j,ileaf) )
+
+          ENDWHERE
+
+          !
+          leaf_mass_young(:) = leaf_mass_young(:) + d_ind(:,j) * bm_sapl(j,ileaf)
+
+          !
+          ! new age class fractions (fraction in youngest class increases)
+          !
+
+          ! youngest class: new mass in youngest class divided by total new mass
+
+          WHERE ( biomass(:,j,ileaf) .GT. min_stomate )
+
+             leaf_frac(:,j,1) = leaf_mass_young(:) / biomass(:,j,ileaf)
+
+          ENDWHERE
+
+          ! other classes: old mass in leaf age class divided by new mass
+
+          DO m = 2, nleafages
+
+             WHERE ( biomass(:,j,ileaf) .GT. min_stomate )
+
+                leaf_frac(:,j,m) = leaf_frac(:,j,m) * & 
+                     ( biomass(:,j,ileaf) + d_ind(:,j) * bm_sapl(j,ileaf) ) /  biomass(:,j,ileaf)
+          
+             ENDWHERE
+
+          ENDDO
+
+          !ENDIF   ! establishment rate is large
+
+          WHERE ( d_ind(:,j) .GT. min_stomate )
+
+             ! 4.5.3 age decreases
 
              age(:,j) = age(:,j) * ind(:,j) / ( ind(:,j) + d_ind(:,j) )
 
-             ! 4.5.3 new number of individuals
+             ! 4.5.4 new number of individuals
 
              ind(:,j) = ind(:,j) + d_ind(:,j)
@@ -484,31 +771,39 @@
           !
 
+          !SZ to clarify with Gerhard Krinner: This is theoretically inconsistent because 
+          ! the allocation to sapwood and leaves do not follow the LPJ logic in stomate_alloc.f90
+          ! hence imposing this here not only solves for the uneveness of age (mixing new and average individual)
+          ! but also corrects for the discrepancy between SLAVE and LPJ logic of allocation, thus leads to excess heartwood
+          ! and thus carbon accumulation!
+          ! should be removed.
+
           IF ( tree(j) ) THEN
 
-             sm2(:) = 0.0
-
-             WHERE ( d_ind(:,j) .GT. 0.0 ) 
-
-                ! ratio of above / total sap parts
-                sm_at(:) = biomass(:,j,isapabove) / &
-                     ( biomass(:,j,isapabove) + biomass(:,j,isapbelow) )
-
-                ! woodmass of an individual
-
-                woodmass(:) = &
-                     ( biomass(:,j,isapabove) + biomass(:,j,isapbelow) + &
-                     biomass(:,j,iheartabove) + biomass(:,j,iheartbelow) ) / ind(:,j)
-
-                ! crown area (m**2) depends on stem diameter (pipe model)
-                dia(:) = ( woodmass(:) / ( pipe_density * pi/4. * pipe_tune2 ) ) &
-                     ** ( 1. / ( 2. + pipe_tune3 ) )
-
-                b1(:) = pipe_k1 / ( sla(j) * pipe_density*pipe_tune2 * dia(:)**pipe_tune3 ) * &
-                     ind(:,j)
-                sm2(:) = lm_lastyearmax(:,j) / b1(:)
-
-             ENDWHERE
-
-             WHERE ( ( d_ind(:,j) .GT. 0.0 ) .AND. &
+!!$             sm2(:) = 0.0
+!!$             WHERE ( d_ind(:,j) .GT. 0.0 ) 
+!!$
+!!$                ! ratio of above / total sap parts
+!!$                sm_at(:) = biomass(:,j,isapabove) / &
+!!$                     ( biomass(:,j,isapabove) + biomass(:,j,isapbelow) )
+!!$
+!!$                ! woodmass of an individual
+!!$
+!!$                woodmass(:) = &
+!!$                     ( biomass(:,j,isapabove) + biomass(:,j,isapbelow) + &
+!!$                     biomass(:,j,iheartabove) + biomass(:,j,iheartbelow) ) / ind(:,j)
+!!$
+!!$                ! crown area (m**2) depends on stem diameter (pipe model)
+!!$                dia(:) = ( woodmass(:) / ( pipe_density * pi/4. * pipe_tune2 ) ) &
+!!$                     ** ( 1. / ( 2. + pipe_tune3 ) )
+!!$
+!!$                b1(:) = pipe_k1 / ( sla(j) * pipe_density*pipe_tune2 * dia(:)**pipe_tune3 ) * &
+!!$                     ind(:,j)
+!!$                sm2(:) = lm_lastyearmax(:,j) / b1(:)
+!!$
+!!$             ENDWHERE
+
+             sm2(:)=biomass(:,j,isapabove) + biomass(:,j,isapbelow)
+
+             WHERE ( ( d_ind(:,j) .GT. min_stomate ) .AND. &
                   ( biomass(:,j,isapabove) + biomass(:,j,isapbelow) ) .GT. sm2(:) )
 
@@ -518,6 +813,6 @@
 
                 biomass(:,j,iheartbelow) = biomass(:,j,iheartbelow) + &
-                     ( biomass(:,j,isapbelow) - sm2(:) * (1. - sm_at) )
-                biomass(:,j,isapbelow) = sm2(:) * (1. - sm_at(:))
+                     ( biomass(:,j,isapbelow) - sm2(:) * (un - sm_at) )
+                biomass(:,j,isapbelow) = sm2(:) * (un - sm_at(:))
 
              ENDWHERE
@@ -536,4 +831,6 @@
 
     CALL histwrite (hist_id_stomate, 'IND_ESTAB', itime, d_ind, npts*nvm, horipft_index)
+    CALL histwrite (hist_id_stomate, 'ESTABTREE', itime, estab_rate_max_tree, npts, hori_index)
+    CALL histwrite (hist_id_stomate, 'ESTABGRASS', itime, estab_rate_max_grass, npts, hori_index)
 
     IF (bavard.GE.4) WRITE(numout,*) 'Leaving establish'
Index: /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/lpj_fire.f90
===================================================================
--- /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/lpj_fire.f90	(revision 256)
+++ /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/lpj_fire.f90	(revision 257)
@@ -99,5 +99,4 @@
     !MM Shilong ??
 !!$    REAL(r_std), PARAMETER                                           :: tau_fire = 365.  ! GKtest
-
     ! fire perturbation
     REAL(r_std), DIMENSION(npts)                                     :: fire_disturb
@@ -273,5 +272,5 @@
        IF(.NOT.disable_fire.AND.natural(j))THEN
           WHERE ( aff(:) .GT. 0.1 )
-             firefrac(:,j) = 1. - ( 1. - aff(:) ) ** (dt/one_year)
+             firefrac(:,j) = un - ( un - aff(:) ) ** (dt/one_year)
           ELSEWHERE
              firefrac(:,j) = aff(:) * dt/one_year
@@ -315,5 +314,5 @@
           ! 4.2.1 Trees: always disturbed
 
-          fire_disturb(:) = ( 1. - resist(j) ) * firefrac(:,j)
+          fire_disturb(:) = ( un - resist(j) ) * firefrac(:,j)
 
        ELSE
@@ -323,5 +322,5 @@
           WHERE ( biomass(:,j,ileaf) .GT. min_stomate )
 
-             fire_disturb(:) = ( 1. - resist(j) ) * firefrac(:,j)
+             fire_disturb(:) = ( un - resist(j) ) * firefrac(:,j)
 
           ELSEWHERE
@@ -353,6 +352,6 @@
              ! 4.3.2 Determine the residue, in gC/m**2 of ground.
 
-             residue(:) = biomass(:,j,k) * fire_disturb(:) * ( 1. - co2frac(k) )
-             !MM in SZ ???        residue(:) = fire_disturb(:) * ( 1. - co2frac(k) )
+             residue(:) = biomass(:,j,k) * fire_disturb(:) * ( un - co2frac(k) )
+             !MM in SZ ???        residue(:) = fire_disturb(:) * ( un - co2frac(k) )
 
              ! 4.3.2.1 determine fraction of black carbon. Only for plant parts above the
@@ -400,5 +399,5 @@
           IF ( .NOT. ( ( .NOT. tree(j) ) .AND. ( ( k.EQ.iroot ) .OR. ( k.EQ.icarbres) ) ) ) THEN
 
-             biomass(:,j,k) = ( 1. - fire_disturb(:) ) * biomass(:,j,k)
+             biomass(:,j,k) = ( un - fire_disturb(:) ) * biomass(:,j,k)
 
           ENDIF
@@ -409,5 +408,5 @@
        !       individuals.
 
-       IF ( control%ok_dgvm .AND. tree(j) ) THEN
+       IF ( (control%ok_dgvm .OR. .NOT.lpj_gap_const_mort) .AND. tree(j) ) THEN
 
           ! fraction of plants that dies each day.
@@ -415,5 +414,5 @@
           firedeath(:,j) = fire_disturb(:) / dt
 
-          ind(:,j) = ( 1. - fire_disturb(:) ) * ind(:,j)
+          ind(:,j) = ( un - fire_disturb(:) ) * ind(:,j)
 
        ENDIF
@@ -440,5 +439,5 @@
 
        litter(:,imetabolic,j,iabove) = litter(:,imetabolic,j,iabove) * &
-            ( 1. - firefrac(:,j) )
+            ( un - firefrac(:,j) )
 
        !
@@ -455,11 +454,20 @@
        co2_fire(:,j) = co2_fire(:,j) + &
             litter(:,istructural,j,iabove) * firefrac(:,j) * &
-            ( 1. - struc_residual(:) )/ dt
+            ( un - struc_residual(:) )/ dt
 
        ! 5.2.3 determine residue (litter that undergoes fire, but is not transformed
        !       into CO2)
 
-       residue(:) = litter(:,istructural,j,iabove) * firefrac(:,j) * &
-            struc_residual(:)
+!NV,MM : We add this test to keep coherence with CMIP5 computations without DGVM.
+!        It has to be removed in trunk version after CMIP5.
+       IF (control%ok_dgvm .OR. .NOT.lpj_gap_const_mort) THEN
+          residue(:) = firefrac(:,j) * struc_residual(:)
+       ELSE
+          residue(:) = litter(:,istructural,j,iabove) * firefrac(:,j) * &
+               struc_residual(:)
+       ENDIF
+
+!       residue(:) = litter(:,istructural,j,iabove) * firefrac(:,j) * &
+!            struc_residual(:)
        !MM in SZ        residue(:) = firefrac(:,j) * struc_residual(:)
 
@@ -482,7 +490,7 @@
 
        litter(:,istructural,j,iabove) = &
-            litter(:,istructural,j,iabove) * ( 1. - firefrac(:,j) ) + &
-            residue(:) * ( 1. - bcfrac(:) )
-       !MM in SZ            residue(:) * ( 1. - bcfrac(:) ) * litter(:,iwoody,j,iabove)
+            litter(:,istructural,j,iabove) * ( un - firefrac(:,j) ) + &
+            residue(:) * ( un - bcfrac(:) )
+       !MM in SZ            residue(:) * ( un - bcfrac(:) ) * litter(:,iwoody,j,iabove)
 
     ENDDO  !  ground
@@ -496,5 +504,5 @@
 
        DO k = 1, nlitt
-          dead_leaves(:,j,k) = dead_leaves(:,j,k) * ( 1. - firefrac(:,j) )
+          dead_leaves(:,j,k) = dead_leaves(:,j,k) * ( un - firefrac(:,j) )
        ENDDO
 
@@ -543,8 +551,6 @@
 
     firefrac_result(:) = &
-!         x(:) * EXP( xm1(:) / ( -.13*xm1(:)*xm1(:)*xm1(:) + .6*xm1(:)*xm1(:) + .8*xm1(:) + .45 ) )
          x(:) * EXP( xm1(:) / ( -firefrac_coeff(4)*xm1(:)*xm1(:)*xm1(:) + firefrac_coeff(3)*xm1(:)*xm1(:) + firefrac_coeff(2)*xm1(:) + firefrac_coeff(1) ) )
 
-
   END FUNCTION firefrac_func
 
Index: /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/lpj_gap.f90
===================================================================
--- /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/lpj_gap.f90	(revision 256)
+++ /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/lpj_gap.f90	(revision 257)
@@ -39,5 +39,5 @@
   SUBROUTINE gap (npts, dt, &
        npp_longterm, turnover_longterm, lm_lastyearmax, &
-       PFTpresent, biomass, ind, bm_to_litter)
+       PFTpresent, biomass, ind, bm_to_litter, mortality)
 
     !
@@ -68,19 +68,20 @@
     ! biomass taken away (gC/(m**2 of ground))
     REAL(r_std), DIMENSION(npts,nvm,nparts), INTENT(inout)  :: bm_to_litter
+    ! mortality (fraction of trees that is dying per time step), per day in history file
+    REAL(r_std), DIMENSION(npts,nvm),INTENT(out)             :: mortality
 
     ! 0.3 local
 
-    ! which kind of mortality
-    LOGICAL, SAVE                                           :: constant_mortality
     ! biomass increase
     REAL(r_std), DIMENSION(npts)                             :: delta_biomass
+    ! biomass increase
+    REAL(r_std), DIMENSION(npts)                             :: dmortality
     ! vigour
     REAL(r_std), DIMENSION(npts)                             :: vigour
     ! natural availability, based on vigour
     REAL(r_std), DIMENSION(npts)                             :: availability
-    ! mortality (fraction of trees that is dying per time step), per day in history file
-    REAL(r_std), DIMENSION(npts,nvm)                        :: mortality
     ! indices
-    INTEGER(i_std)                                           :: j,k
+    INTEGER(i_std)                                           :: j,k,m
+    REAL(r_std) :: ref_greff
 
     ! =========================================================================
@@ -90,21 +91,12 @@
        firstcall = .FALSE.
 
-       !Config  Key  = LPJ_GAP_CONST_MORT
-       !Config  Desc = constant tree mortality
-       !Config  Def  = y
-       !Config  Help = If yes, then a constant mortality is applied to trees. 
-       !Config         Otherwise, mortality is a function of the trees' 
-       !Config         vigour (as in LPJ).
-
-       constant_mortality = .TRUE.
-       CALL getin_p('LPJ_GAP_CONST_MORT', constant_mortality)     
-       WRITE(numout,*) 'gap: constant mortality:', constant_mortality
-
     ENDIF
 
-    IF (bavard.GE.3) WRITE(numout,*) 'Entering gap'
+    IF (bavard.GE.3) WRITE(numout,*) 'Entering gap',lpj_gap_const_mort
 
     mortality(:,:) = zero
 
+    ref_greff =  0.035
+
     DO j = 2,nvm
 
@@ -117,5 +109,5 @@
           !
 
-          IF ( .NOT. constant_mortality ) THEN
+          IF ( .NOT.  lpj_gap_const_mort  ) THEN
 
              !
@@ -125,14 +117,22 @@
              WHERE ( PFTpresent(:,j) .AND. ( lm_lastyearmax(:,j) .GT. min_stomate ) )
 
+!SZ 080806, changed to LPJ formulation according to Smith et al., 2001 
+
                 ! how much did the tree grow per year?
 
-                delta_biomass(:) = &
-                     MAX( npp_longterm(:,j) - ( turnover_longterm(:,j,ileaf) + &
-                     turnover_longterm(:,j,iroot) + turnover_longterm(:,j,ifruit) ), &
-                     zero )
+!!$                delta_biomass(:) = &
+!!$                     MAX( npp_longterm(:,j) - ( turnover_longterm(:,j,ileaf) + &
+!!$                     turnover_longterm(:,j,iroot) + turnover_longterm(:,j,ifruit) ), &
+!!$                     0._r_std )
+
+            ! note that npp_longterm is now actually longterm growth efficiency (NPP/LAI)
+            ! to be fair to deciduous trees
+             delta_biomass(:) = MAX( npp_longterm(:,j) - ( turnover_longterm(:,j,ileaf) + &
+                  turnover_longterm(:,j,iroot) + turnover_longterm(:,j,ifruit) + & 
+                  turnover_longterm(:,j,isapabove) + turnover_longterm(:,j,isapbelow) ) ,zero)
 
                 ! scale this to the leaf surface of the tree
-
-                vigour(:) = delta_biomass(:) / (lm_lastyearmax(:,j)*sla(j)) / vigour_coeff
+!!$                vigour(:) = delta_biomass(:) / (lm_lastyearmax(:,j)*sla(j)) / vigour_coeff
+             vigour(:) = delta_biomass(:) / (lm_lastyearmax(:,j)*sla(j))
 
              ELSEWHERE
@@ -147,5 +147,9 @@
                 ! low vigour.
 
-                availability(:) = availability_fact / ( 1.+vigour(:)/vigour_ref)
+!SZ 080806, changed to LPJ formulation according to Smith et al., 2001 
+! tuned maximal mortality to 0.05 to get realistic range of avergage age to get ~100 years at GREFF=100
+! for the range of modelled annual NPP
+!!$                availability(:) = min_avail / ( 1.+vigour(:)/vigour_ref )
+                availability(:) = 0.1 / ( 1.+ref_greff*vigour(:) )
 
                 ! Mortality (fraction per time step).
@@ -158,5 +162,6 @@
                 ! approximation ok as availability < 0.02 << 1
 
-                mortality(:,j) = availability(:) * dt/one_year
+                mortality(:,j) = MAX(min_avail,availability(:))  * dt/one_year  
+!!$                mortality(:,j) = availability(:) * dt/one_year
 
              ENDWHERE
@@ -199,7 +204,8 @@
              WHERE ( PFTpresent(:,j) )
 
-                bm_to_litter(:,j,k) = bm_to_litter(:,j,k) + mortality(:,j) * biomass(:,j,k)
-
-                biomass(:,j,k) = biomass(:,j,k) * ( 1. - mortality(:,j) )
+                dmortality(:) =  mortality(:,j) * biomass(:,j,k)
+                bm_to_litter(:,j,k) = bm_to_litter(:,j,k) + dmortality(:)
+                
+                biomass(:,j,k) = biomass(:,j,k) - dmortality(:)
 
              ENDWHERE
@@ -211,12 +217,37 @@
           !
 
-          IF ( control%ok_dgvm ) THEN
-
-             WHERE ( PFTpresent(:,j) )
-
-                ind(:,j) = ind(:,j) * ( 1. - mortality(:,j) )
-
-             ENDWHERE
-
+!SZ 080806, allow changing density in static case when mortality is dynamic
+          IF ( control%ok_dgvm .OR. .NOT.lpj_gap_const_mort) THEN
+
+             WHERE ( PFTpresent(:,j) )
+
+                ind(:,j) = ind(:,j) * ( un - mortality(:,j) )
+
+             ENDWHERE
+
+          ENDIF
+
+       ELSE 
+
+          IF ( .NOT.control%ok_dgvm .AND. .NOT.lpj_gap_const_mort) THEN
+
+             WHERE ( PFTpresent(:,j) .AND. ( npp_longterm(:,j) .LE. 10. ) )
+
+                mortality(:,j) = 1.
+
+             ENDWHERE
+             DO k = 1, nparts
+
+                WHERE ( PFTpresent(:,j) )
+
+                   dmortality(:) =  mortality(:,j) * biomass(:,j,k)
+                   
+                   bm_to_litter(:,j,k) = bm_to_litter(:,j,k) + dmortality(:)
+                   
+                   biomass(:,j,k) = biomass(:,j,k) - dmortality(:)
+
+                ENDWHERE
+             ENDDO
+             
           ENDIF
 
Index: /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/lpj_kill.f90
===================================================================
--- /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/lpj_kill.f90	(revision 256)
+++ /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/lpj_kill.f90	(revision 257)
@@ -25,5 +25,5 @@
   SUBROUTINE kill (npts, whichroutine, lm_lastyearmax, &
        ind, PFTpresent, cn_ind, biomass, senescence, RIP_time, &
-       lai, age, leaf_age, leaf_frac, &
+       lai, age, leaf_age, leaf_frac, npp_longterm, &
        when_growthinit, everywhere, veget, veget_max, bm_to_litter)
 
@@ -37,5 +37,5 @@
     INTEGER(i_std), INTENT(in)                                       :: npts
     ! message
-    CHARACTER*10, INTENT(in)                                  :: whichroutine
+    CHARACTER(LEN=10), INTENT(in)                                  :: whichroutine
     ! last year's maximum leaf mass, for each PFT (gC/(m**2 of ground))
     REAL(r_std), DIMENSION(npts,nvm), INTENT(in)              :: lm_lastyearmax
@@ -72,4 +72,6 @@
     ! "maximal" coverage fraction of a PFT (LAI -> infinity) on ground
     REAL(r_std), DIMENSION(npts,nvm), INTENT(inout)           :: veget_max
+    ! "long term" net primary productivity (gC/(m**2 of ground)/year)
+    REAL(r_std), DIMENSION(npts,nvm), INTENT(inout)           :: npp_longterm 
     ! conversion of biomass to litter (gC/(m**2 of ground)) / day
     REAL(r_std), DIMENSION(npts,nvm,nparts), INTENT(inout)    :: bm_to_litter
@@ -98,17 +100,36 @@
           ! the "was_killed" business is necessary for a more efficient code on the VPP
 
-          WHERE ( PFTpresent(:,j) .AND. &
-               ( ( ind(:,j) .LT. min_stomate ) .OR. &
-               ( lm_lastyearmax(:,j) .LT. min_stomate ) ) )
-
+          IF ( control%ok_dgvm ) THEN
+             WHERE ( PFTpresent(:,j) .AND. &
+                  ( ( ind(:,j) .LT. min_stomate ) .OR. &
+                  ( lm_lastyearmax(:,j) .LT. min_stomate ) ) )
+             
              was_killed(:) = .TRUE.
-
-          ENDWHERE
+             
+             ENDWHERE
+          
+          ELSE
+             WHERE ( PFTpresent(:,j) .AND. & 
+                  (biomass(:,j,icarbres) .LE.zero .OR. & 
+                  biomass(:,j,iroot).LT.-min_stomate .OR. biomass(:,j,ileaf).LT.-min_stomate ).AND. & 
+                  ind(:,j).GT. zero)
+
+                was_killed(:) = .TRUE.
+
+             ENDWHERE
+
+             IF(.NOT.tree(j).AND..NOT.lpj_gap_const_mort)THEN
+                WHERE ( was_killed(:) )
+
+                   npp_longterm(:,j)=500.
+
+                ENDWHERE
+             ENDIF
+
+          ENDIF
 
           IF ( ANY( was_killed(:) ) ) THEN
 
              WHERE ( was_killed(:) )
-
-                ind(:,j) = 0.0
 
                 bm_to_litter(:,j,ileaf) = bm_to_litter(:,j,ileaf) + biomass(:,j,ileaf)
@@ -123,31 +144,45 @@
                 bm_to_litter(:,j,icarbres) = bm_to_litter(:,j,icarbres) + biomass(:,j,icarbres)
 
-                biomass(:,j,ileaf) = 0.0
-                biomass(:,j,isapabove) = 0.0
-                biomass(:,j,isapbelow) = 0.0
-                biomass(:,j,iheartabove) = 0.0
-                biomass(:,j,iheartbelow) = 0.0
-                biomass(:,j,iroot) = 0.0
-                biomass(:,j,ifruit) = 0.0
-                biomass(:,j,icarbres) = 0.0
-
-                PFTpresent(:,j) = .FALSE.
-
-                cn_ind(:,j) = 0.0
+                biomass(:,j,ileaf) = zero
+                biomass(:,j,isapabove) = zero
+                biomass(:,j,isapbelow) = zero
+                biomass(:,j,iheartabove) = zero
+                biomass(:,j,iheartbelow) = zero
+                biomass(:,j,iroot) = zero
+                biomass(:,j,ifruit) = zero
+                biomass(:,j,icarbres) = zero
+
+             ENDWHERE   ! number of individuals very low
+
+             IF (control%ok_dgvm) THEN
+
+                WHERE ( was_killed(:) )
+                   PFTpresent(:,j) = .FALSE.
+
+                   veget_max(:,j) = zero
+                   
+                   RIP_time(:,j) = zero
+
+                ENDWHERE  ! number of individuals very low
+
+             ENDIF
+
+             WHERE ( was_killed(:) )
+
+                ind(:,j) = zero
+
+                cn_ind(:,j) = zero
 
                 senescence(:,j) = .FALSE.
 
-
-                age(:,j) = 0.0
-
-                when_growthinit(:,j) = undef
-
-                everywhere(:,j) = 0.0
-
-                veget(:,j) = 0.0
-
-                veget_max(:,j) = 0.0
-
-                RIP_time(:,j) = 0.0
+                age(:,j) = zero
+
+                ! SZ: why undef ??? this causes a delay in reestablishment
+                !when_growthinit(:,j) = undef
+                when_growthinit(:,j) = large_value 
+
+                everywhere(:,j) = zero
+
+                veget(:,j) = zero
 
              ENDWHERE   ! number of individuals very low
@@ -157,6 +192,6 @@
                 WHERE ( was_killed(:) )
 
-                   leaf_age(:,j,m) = 0.0 
-                   leaf_frac(:,j,m) = 0.0 
+                   leaf_age(:,j,m) = zero 
+                   leaf_frac(:,j,m) = zero 
 
                 ENDWHERE
